## mingw-w64-freecad-1.0rc2-1.src.tar.zst

=== CMakeLists.txt ===
# As of January 2023 we require CMake 3.16.3
# see https://forum.freecad.org/viewtopic.php?f=10&t=72173
# for further info why
cmake_minimum_required(VERSION 3.16.3 FATAL_ERROR)

# policy CMP0072 was introduced with CMake 3.11
# relates to FindOpenGL module
# and cache variables OPENGL_gl_LIBRARY, OPENGL_glu_LIBRARY
if (POLICY CMP0072)
    set(OpenGL_GL_PREFERENCE LEGACY)
endif(POLICY CMP0072)

# FindPythonInterp and FindPythonLibs modules are deprecated.
# Currently, they are still used by shiboken's CMake files
if (POLICY CMP0148)
    cmake_policy(SET CMP0148 OLD)
endif()

option(FREECAD_USE_CCACHE "Auto detect and use ccache during compilation" ON)

if(FREECAD_USE_CCACHE)
    find_program(CCACHE_PROGRAM ccache)  #This check should occur before project()
    if(CCACHE_PROGRAM)
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
    endif()
endif()

project(FreeCAD)

set(PACKAGE_VERSION_MAJOR "1")
set(PACKAGE_VERSION_MINOR "0")
set(PACKAGE_VERSION_PATCH "0") # number of patch release (e.g. "4" for the 0.18.4 release)
set(PACKAGE_VERSION_SUFFIX "RC2") # either "dev" for development snapshot or "" (empty string)
set(PACKAGE_BUILD_VERSION "0") # used when the same FreeCAD version will be re-released (for example using an updated LibPack)

set(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH}")
set(PACKAGE_STRING "${PROJECT_NAME} ${PACKAGE_VERSION}")

# include local modules
include(CheckCXXCompilerFlag)
include(AddFileDependencies)
include(cMake/FreeCadMacros.cmake)
# include helper functions/macros
add_subdirectory(cMake/FreeCAD_Helpers)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cMake")

CompilerChecksAndSetups()
ConfigureCMakeVariables()
InitializeFreeCADBuildOptions()
CheckInterModuleDependencies()
FreeCADLibpackChecks()
SetupDoxygen()
SetupLibFmt()
SetupYamlCpp()
if(NOT FREECAD_LIBPACK_USE OR FREECAD_LIBPACK_CHECKFILE_CLBUNDLER OR FREECAD_LIBPACK_CHECKFILE_VERSION)
    SetupPython()
    SetupPCL()
    SetupPybind11()
    SetupXercesC()
    find_package(ZLIB REQUIRED)
    find_package(PyCXX REQUIRED)
    SetupOpenCasCade()
    if(BUILD_GUI)
        # Do this before the check for SMESH because it depends on vtk
        # that may have its own OpenGL check but possibly fails and leaves
        # OPENGL_gl_LIBRARY empty that results into linker errors
        SetupOpenGL()
    endif(BUILD_GUI)
    SetupBoost()
    SetupSalomeSMESH()
    if (BUILD_FEM_NETGEN)
        find_package(NETGEN)
    endif(BUILD_FEM_NETGEN)
    # not needed at the moment
    #find_package(OpenCV REQUIRED)
    SetupSwig()
    SetupEigen()
    # This file is included directly due to some cMake macros that are defined within.
    # If these macro definitions are embedded within another macro, it causes problems.
    include(cMake/FreeCAD_Helpers/SetupQt.cmake)
    SetupFreetype()

    if(BUILD_GUI)
        SetupCoin3D()
        SetupSpaceball()
        SetupShibokenAndPyside()
        SetupMatplotlib()
    endif(BUILD_GUI)
endif()

if(BUILD_VR)
    find_package(Rift)
endif(BUILD_VR)

SetLibraryVersions()
SetGlobalCompilerAndLinkerSettings()

add_subdirectory(src)
add_subdirectory(data)

BuildAndInstallDesignerPlugin()

CreatePackagingTargets()

if(MSVC AND FREECAD_LIBPACK_USE AND LIBPACK_FOUND)
    CopyLibpackDirectories()
endif()

if (ENABLE_DEVELOPER_TESTS)
    include(CTest)
    enable_testing()
    add_subdirectory(tests)
endif()

PrintFinalReport()

message("\n=================================================\n"
        "Now run 'cmake --build ${CMAKE_BINARY_DIR}' to build ${PROJECT_NAME}\n"
        "=================================================\n")

=== data/examples/CMakeLists.txt ===

SET(Examples_Files
    Schenkel.stp
    draft_test_objects.FCStd
    EngineBlock.FCStd
    PartDesignExample.FCStd
    RobotExample.FCStd
    BIMExample.FCStd
    FEMExample.FCStd
    AssemblyExample.FCStd
)

ADD_CUSTOM_TARGET(Example_data ALL
    SOURCES ${Examples_Files}
)

# 0001097: CMake stops with error "Circular ... <- ... dependency dropped."
if(NOT "${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    fc_copy_sources(Example_data "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/examples" ${Examples_Files})
endif()

if (WIN32 AND FREECAD_LIBPACK_USE)
    # pivy
    foreach (it ${FREECAD_LIBPACK_PIVY_COIN})
        get_filename_component(libfile ${it} NAME)
        set(out "${CMAKE_BINARY_DIR}/lib/pivy/${libfile}")
        add_custom_command(
            DEPENDS   ${it}
            OUTPUT    ${out}
            COMMAND   ${CMAKE_COMMAND}
            ARGS      -E copy_if_different ${it} ${out}
            MAIN_DEPENDENCY ${it}
            COMMENT   "Copy file to ${out}"
    )
    endforeach (it)
    SOURCE_GROUP("pivy" FILES ${FREECAD_LIBPACK_PIVY_COIN})

    # shiboken
    foreach (it ${FREECAD_LIBPACK_SHIBOKEN})
        get_filename_component(libfile ${it} NAME)
        set(out "${CMAKE_BINARY_DIR}/lib/${libfile}")
        add_custom_command(
            DEPENDS   ${it}
            OUTPUT    ${out}
            COMMAND   ${CMAKE_COMMAND}
            ARGS      -E copy_if_different ${it} ${out}
            MAIN_DEPENDENCY ${it}
            COMMENT   "Copy file to ${out}"
    )
    endforeach (it)
    SOURCE_GROUP("Shiboken" FILES ${FREECAD_LIBPACK_SHIBOKEN})

    # PySide
    foreach (it ${FREECAD_LIBPACK_PYSIDE})
        get_filename_component(libfile ${it} NAME)
        set(out "${CMAKE_BINARY_DIR}/lib/PySide/${libfile}")
        add_custom_command(
            DEPENDS   ${it}
            OUTPUT    ${out}
            COMMAND   ${CMAKE_COMMAND}
            ARGS      -E copy_if_different ${it} ${out}
            MAIN_DEPENDENCY ${it}
            COMMENT   "Copy file to ${out}"
    )
    endforeach (it)
    SOURCE_GROUP("PySide" FILES ${FREECAD_LIBPACK_PYSIDE})

    # PySide tools
    foreach (it ${FREECAD_LIBPACK_PYSIDEUIC})
        get_filename_component(libpath ${it} PATH)
        set(src "${FREECAD_LIBPACK_PYSIDEUIC_REL}/${it}")
        if("${libpath}" STREQUAL "pysideuic")
            set(FREECAD_LIBPACK_PYSIDEUIC_TOP ${FREECAD_LIBPACK_PYSIDEUIC_TOP} ${src})
        elseif("${libpath}" STREQUAL "pysideuic/Compiler")
            set(FREECAD_LIBPACK_PYSIDEUIC_CMP ${FREECAD_LIBPACK_PYSIDEUIC_CMP} ${src})
        elseif("${libpath}" STREQUAL "pysideuic/port_v2")
            set(FREECAD_LIBPACK_PYSIDEUIC_PV2 ${FREECAD_LIBPACK_PYSIDEUIC_PV2} ${src})
        elseif("${libpath}" STREQUAL "pysideuic/port_v3")
            set(FREECAD_LIBPACK_PYSIDEUIC_PV3 ${FREECAD_LIBPACK_PYSIDEUIC_PV3} ${src})
        elseif("${libpath}" STREQUAL "pysideuic/widget-plugins")
            set(FREECAD_LIBPACK_PYSIDEUIC_WPL ${FREECAD_LIBPACK_PYSIDEUIC_WPL} ${src})
        else()
            set(FREECAD_LIBPACK_PYSIDEUIC_OTH ${FREECAD_LIBPACK_PYSIDEUIC_OTH} ${src})
        endif()
        set(FREECAD_LIBPACK_PYSIDEUIC_ABS ${FREECAD_LIBPACK_PYSIDEUIC_ABS} ${src})
        set(out "${CMAKE_BINARY_DIR}/lib/${it}")
        add_custom_command(
            DEPENDS   ${src}
            OUTPUT    ${out}
            COMMAND   ${CMAKE_COMMAND}
            ARGS      -E copy_if_different ${src} ${out}
            MAIN_DEPENDENCY ${src}
            COMMENT   "Copy file to ${out}"
    )
    endforeach (it)
    SOURCE_GROUP("PySide tools" FILES ${FREECAD_LIBPACK_PYSIDEUIC_OTH})
    SOURCE_GROUP("PySide tools\\pysideuic" FILES ${FREECAD_LIBPACK_PYSIDEUIC_TOP})
    SOURCE_GROUP("PySide tools\\pysideuic\\Compiler" FILES ${FREECAD_LIBPACK_PYSIDEUIC_CMP})
    SOURCE_GROUP("PySide tools\\pysideuic\\port_v2" FILES ${FREECAD_LIBPACK_PYSIDEUIC_PV2})
    SOURCE_GROUP("PySide tools\\pysideuic\\port_v3" FILES ${FREECAD_LIBPACK_PYSIDEUIC_PV3})
    SOURCE_GROUP("PySide tools\\pysideuic\\widget-plugins" FILES ${FREECAD_LIBPACK_PYSIDEUIC_WPL})

    # Python extension modules
    foreach (it ${FREECAD_LIBPACK_PYTHON})
        get_filename_component(libfile ${it} NAME)
        set(out "${CMAKE_BINARY_DIR}/lib/${libfile}")
        add_custom_command(
            DEPENDS   ${it}
            OUTPUT    ${out}
            COMMAND   ${CMAKE_COMMAND}
            ARGS      -E copy_if_different ${it} ${out}
            MAIN_DEPENDENCY ${it}
            COMMENT   "Copy file to ${out}"
    )
    endforeach (it)
    SOURCE_GROUP("Python" FILES ${FREECAD_LIBPACK_PYTHON})

    set(FREECAD_LIBPACK_FILES
        ${FREECAD_LIBPACK_PIVY_COIN}
        ${FREECAD_LIBPACK_SHIBOKEN}
        ${FREECAD_LIBPACK_PYSIDE}
        ${FREECAD_LIBPACK_PYSIDEUIC_ABS}
        ${FREECAD_LIBPACK_PYTHON}
    )
    add_custom_target(LibPack_Files ALL SOURCES ${FREECAD_LIBPACK_FILES})

endif(WIN32 AND FREECAD_LIBPACK_USE)

INSTALL(
    FILES
        ${Examples_Files}
    DESTINATION
        ${CMAKE_INSTALL_DATADIR}/examples
)

=== src/Gui/CMakeLists.txt ===
#add_subdirectory(Icons)
add_subdirectory(Stylesheets)
add_subdirectory(PreferencePacks)
add_subdirectory(PreferencePackTemplates)

if(WIN32)
add_definitions(-DFCGui -DQSINT_MAKEDLL -DOVR_OS_WIN32 -DQUARTER_INTERNAL -DQUARTER_MAKE_DLL -DCOIN_DLL)
endif(WIN32)

IF(CMAKE_BUILD_TYPE)
    add_definitions(-DCMAKE_BUILD_TYPE="${CMAKE_BUILD_TYPE}")
ENDIF(CMAKE_BUILD_TYPE)

if (FREECAD_USE_3DCONNEXION)
    add_definitions(-D_USE_3DCONNEXION_SDK)
    if(APPLE)
        set(3DCONNEXION_LINKFLAGS "-F/Library/Frameworks -weak_framework 3DconnexionClient")
        set(3DCONNEXION_INCLUDE_DIR ${3DCONNEXIONCLIENT_FRAMEWORK}/Headers
                                    ${3DCONNEXIONCLIENT_FRAMEWORK}/Headers/3DconnexionClient )
    endif(APPLE)
endif(FREECAD_USE_3DCONNEXION)

if(FREECAD_USE_3DCONNEXION_NAVLIB AND (MSVC OR APPLE))
    add_definitions(-DUSE_3DCONNEXION_NAVLIB)
    if(APPLE)
        add_definitions(-D__APPLE__)
    endif(APPLE)
    set(3DCONNEXION_INCLUDE_DIR ${CMAKE_SOURCE_DIR}/src/3rdParty/3Dconnexion/inc)
endif(FREECAD_USE_3DCONNEXION_NAVLIB AND (MSVC OR APPLE))

if (BUILD_VR)
    add_definitions(-DBUILD_VR )
endif(BUILD_VR)

if (BUILD_ADDONMGR)
    add_definitions(-DBUILD_ADDONMGR )
endif(BUILD_ADDONMGR)

include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/Quarter
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/..
    ${CMAKE_CURRENT_BINARY_DIR}/..
    ${CMAKE_CURRENT_BINARY_DIR}/Language
    ${CMAKE_CURRENT_BINARY_DIR}/propertyeditor
    ${CMAKE_CURRENT_BINARY_DIR}/TaskView
    ${CMAKE_CURRENT_BINARY_DIR}/Quarter
    ${CMAKE_CURRENT_BINARY_DIR}/DAGView
    ${Boost_INCLUDE_DIRS}
    ${EIGEN3_INCLUDE_DIR}
    ${COIN3D_INCLUDE_DIRS}
    ${PYTHON_INCLUDE_DIRS}
    ${XercesC_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${3DCONNEXION_INCLUDE_DIR}
)

if(MSVC)
    include_directories(
        ${CMAKE_SOURCE_DIR}/src/3rdParty/OpenGL/api
    )
endif(MSVC)

if(MSVC)
    set(FreeCADGui_LIBS
         FreeCADApp
         ${COIN3D_LIBRARIES}
         ${OPENGL_gl_LIBRARY}
    )

    if(FREECAD_USE_3DCONNEXION)
        list(APPEND FreeCADGui_LIBS
            hid
        )
    endif()

else(MSVC)
    set(FreeCADGui_LIBS
        FreeCADApp
        ${COIN3D_LIBRARIES}
        ${Boost_LIBRARIES}
        ${OPENGL_gl_LIBRARY}
        ${3DCONNEXION_LINKFLAGS}
    )
endif(MSVC)

if (WIN32)
    if(FREECAD_QT_MAJOR_VERSION EQUAL 6)
        list(APPEND FreeCADGui_LIBS
            Qt6::GuiPrivate
        )
    endif()
endif()

include_directories(
    ${QtCore_INCLUDE_DIRS}
    ${QtWidgets_INCLUDE_DIRS}
    ${QtOpenGL_INCLUDE_DIRS}
    ${QtPrintSupport_INCLUDE_DIRS}
    ${QtSvg_INCLUDE_DIRS}
    ${QtSvgWidgets_INCLUDE_DIRS}
    ${QtNetwork_INCLUDE_DIRS}
    ${QtUiTools_INCLUDE_DIRS}
    ${QtXml_INCLUDE_DIRS}
)
list(APPEND FreeCADGui_LIBS
    ${QtCore_LIBRARIES}
    ${QtWidgets_LIBRARIES}
    ${QtOpenGL_LIBRARIES}
    ${QtPrintSupport_LIBRARIES}
    ${QtSvg_LIBRARIES}
    ${QtSvgWidgets_LIBRARIES}
    ${QtNetwork_LIBRARIES}
    ${QtUiTools_LIBRARIES}
)

if(${Qt5WinExtras_FOUND})
    include_directories(
        ${Qt5WinExtras_INCLUDE_DIRS}
    )
    list(APPEND FreeCADGui_LIBS
        ${Qt5WinExtras_LIBRARIES}
    )
endif()

IF(SPNAV_FOUND)
    if(SPNAV_USE_X11)
        add_definitions(-DSPNAV_USE_X11)
        if (FREECAD_QT_MAJOR_VERSION EQUAL 5 AND UNIX AND NOT APPLE)
            find_package(Qt5X11Extras REQUIRED)
            include_directories(${Qt5X11Extras_INCLUDE_DIRS})
            list(APPEND FreeCADGui_LIBS ${Qt5X11Extras_LIBRARIES})
            # Note that Qt6 has removed the QtX11Extras files
        endif()
        find_package(X11 QUIET)
        if (X11_FOUND)
            list(APPEND FreeCADGui_LIBS
                ${X11_X11_LIB}
            )
        endif(X11_FOUND)
        SET(FreeCADGui_SDK_SRCS
            3Dconnexion/GuiAbstractNativeEvent.cpp
            3Dconnexion/GuiNativeEventLinuxX11.cpp
            )
        SET(FreeCADGui_SDK_MOC_HDRS
            3Dconnexion/GuiAbstractNativeEvent.h
            3Dconnexion/GuiNativeEventLinuxX11.h
            )
    else(SPNAV_USE_X11)
        SET(FreeCADGui_SDK_SRCS
            3Dconnexion/GuiAbstractNativeEvent.cpp
            3Dconnexion/GuiNativeEventLinux.cpp
            )
        SET(FreeCADGui_SDK_MOC_HDRS
            3Dconnexion/GuiAbstractNativeEvent.h
            3Dconnexion/GuiNativeEventLinux.h
            )
    endif(SPNAV_USE_X11)
    SOURCE_GROUP("3D connexion SDK" FILES ${FreeCADGui_SDK_SRCS})

    add_definitions(-DSPNAV_FOUND)
    include_directories(
        ${SPNAV_INCLUDE_DIR}
    )
    list(APPEND FreeCADGui_LIBS
        ${SPNAV_LIBRARIES}
    )
ENDIF(SPNAV_FOUND)

IF(OCULUS_FOUND)
    add_definitions(-DOCULUS_FOUND)
    include_directories(
        ${OCULUS_INCLUDE_DIRS}
    )
    list(APPEND FreeCADGui_LIBS
        ${OCULUS_LIBRARIES}
    )
ENDIF(OCULUS_FOUND)

if(FREECAD_USE_SHIBOKEN)
    add_definitions(-DHAVE_SHIBOKEN${PYSIDE_MAJOR_VERSION})
    include_directories(
        ${SHIBOKEN_INCLUDE_DIR}
    )
    if (SHIBOKEN_LIBRARY)
        list(APPEND FreeCADGui_LIBS
            ${SHIBOKEN_LIBRARY}
        )
    else (SHIBOKEN_LIBRARY)
        if (TARGET Shiboken2::libshiboken)
            list(APPEND FreeCADGui_LIBS
                Shiboken2::libshiboken
            )
        elseif (TARGET Shiboken6::libshiboken)
            list(APPEND FreeCADGui_LIBS
                Shiboken6::libshiboken
            )
        endif (TARGET Shiboken2::libshiboken)
    endif (SHIBOKEN_LIBRARY)
endif(FREECAD_USE_SHIBOKEN)

if(FREECAD_USE_PYSIDE)
    include_directories(
        ${PYSIDE_INCLUDE_DIR}
        ${PYSIDE_INCLUDE_DIR}/QtCore
        ${PYSIDE_INCLUDE_DIR}/QtGui
    )
    if (PYSIDE_LIBRARY)
        list(APPEND FreeCADGui_LIBS
            ${PYSIDE_LIBRARY}
        )
    else (PYSIDE_LIBRARY)
        if (TARGET PySide2::pyside2)
            list(APPEND FreeCADGui_LIBS
                PySide2::pyside2
            )
        elseif (TARGET PySide6::pyside6)
            list(APPEND FreeCADGui_LIBS
                PySide6::pyside6
            )
        endif ()
    endif (PYSIDE_LIBRARY)
    include_directories(
        ${PYSIDE_INCLUDE_DIR}/QtWidgets
    )
    add_definitions(-DHAVE_PYSIDE${PYSIDE_MAJOR_VERSION})
endif(FREECAD_USE_PYSIDE)

generate_from_xml(DocumentPy)
generate_from_xml(PythonWorkbenchPy)
generate_from_xml(ViewProviderPy)
generate_from_xml(ViewProviderDocumentObjectPy)
generate_from_xml(ViewProviderGeometryObjectPy)
generate_from_xml(ViewProviderExtensionPy)
generate_from_xml(WorkbenchPy)
generate_from_xml(SelectionObjectPy)
generate_from_xml(LinkViewPy)
generate_from_xml(ViewProviderLinkPy)
generate_from_xml(AxisOriginPy)
generate_from_xml(CommandPy)

generate_from_py(FreeCADGuiInit GuiInitScript.h)

# The XML files
SET(FreeCADGui_XML_SRCS
    ViewProviderDocumentObjectPy.xml
    ViewProviderGeometryObjectPy.xml
    ViewProviderPy.xml
    ViewProviderExtensionPy.xml
    PythonWorkbenchPy.xml
    WorkbenchPy.xml
    SelectionObjectPy.xml
    DocumentPy.xml
    LinkViewPy.xml
    ViewProviderLinkPy.xml
    AxisOriginPy.xml
    CommandPy.xml
)
SOURCE_GROUP("XML" FILES ${FreeCADApp_XML_SRCS})

# The 3D Connexion SDK files
if(FREECAD_USE_3DCONNEXION AND MSVC)
SET(FreeCADGui_SDK_SRCS
    3Dconnexion/I3dMouseParams.h
    3Dconnexion/MouseParameters.cpp
    3Dconnexion/MouseParameters.h
    3Dconnexion/GuiAbstractNativeEvent.cpp
    3Dconnexion/GuiNativeEventWin32.cpp
)
SOURCE_GROUP("3D connexion SDK" FILES ${FreeCADGui_SDK_SRCS})
SET(FreeCADGui_SDK_MOC_HDRS
  3Dconnexion/GuiAbstractNativeEvent.h
  3Dconnexion/GuiNativeEventWin32.h
)
endif(FREECAD_USE_3DCONNEXION AND MSVC)

if(FREECAD_USE_3DCONNEXION AND APPLE)
SET(FreeCADGui_SDK_SRCS
    3Dconnexion/GuiAbstractNativeEvent.cpp
    3Dconnexion/GuiNativeEventMac.cpp
)
SOURCE_GROUP("3D connexion SDK" FILES ${FreeCADGui_SDK_SRCS})
SET(FreeCADGui_SDK_MOC_HDRS
  3Dconnexion/GuiAbstractNativeEvent.h
  3Dconnexion/GuiNativeEventMac.h
)
endif(FREECAD_USE_3DCONNEXION AND APPLE)

if(FREECAD_USE_3DCONNEXION_NAVLIB AND (MSVC OR APPLE))
    SET(NAVLIB_STUB_DIR ${CMAKE_SOURCE_DIR}/src/3rdParty/3Dconnexion/src)
    SET(FreeCADGui_SDK_SRCS
        3Dconnexion/navlib/NavlibCmds.cpp
        3Dconnexion/navlib/NavlibNavigation.cpp
        3Dconnexion/navlib/NavlibPivot.cpp
        ${NAVLIB_STUB_DIR}/navlib_load.cpp
        ${NAVLIB_STUB_DIR}/navlib_stub.c
    )
    SOURCE_GROUP("3Dconnexion Navlib" FILES ${FreeCADGui_SDK_SRCS})
	SET(FreeCADGui_SDK_MOC_HDRS
        3Dconnexion/navlib/NavlibInterface.h
	)
endif(FREECAD_USE_3DCONNEXION_NAVLIB AND (MSVC OR APPLE))

set_property(SOURCE GraphvizView.h GraphvizView.cpp PROPERTY SKIP_AUTOMOC ON)
add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/moc_GraphvizView-internal.cpp
    COMMAND ${QtCore_MOC_EXECUTABLE} -o ${CMAKE_CURRENT_BINARY_DIR}/moc_GraphvizView-internal.cpp ${CMAKE_CURRENT_SOURCE_DIR}/GraphvizView.cpp
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/GraphvizView.cpp)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/moc_GraphvizView.cpp
    COMMAND ${QtCore_MOC_EXECUTABLE} -o ${CMAKE_CURRENT_BINARY_DIR}/moc_GraphvizView.cpp ${CMAKE_CURRENT_SOURCE_DIR}/GraphvizView.h
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/GraphvizView.h)

set_property(SOURCE GraphvizView.cpp APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/moc_GraphvizView-internal.cpp)
set_property(SOURCE GraphvizView.h APPEND PROPERTY OBJECT_DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/moc_GraphvizView.cpp)

SET(Gui_UIC_SRCS
    AboutApplication.ui
    Clipping.ui
    DemoMode.ui
    DlgActions.ui
    DlgActivateWindow.ui
    DlgUnitsCalculator.ui
    DlgAuthorization.ui
    DlgChooseIcon.ui
    DlgCreateNewPreferencePack.ui
    DlgInputDialog.ui
    DlgKeyboard.ui
    DlgMacroExecute.ui
    DlgRunExternal.ui
    DlgMacroRecord.ui
    DlgMaterialProperties.ui
    DlgOnlineHelp.ui
    DlgParameter.ui
    DlgParameterFind.ui
    DlgPreferencePackManagement.ui
    DlgPreferences.ui
    DlgProjectInformation.ui
    DlgProjectUtility.ui
    DlgPropertyLink.ui
    DlgRevertToBackupConfig.ui
    PreferencePages/DlgSettings3DView.ui
    PreferencePages/DlgSettingsCacheDirectory.ui
    DlgSettingsColorGradient.ui
    PreferencePages/DlgSettingsDocument.ui
    PreferencePages/DlgSettingsEditor.ui
    PreferencePages/DlgSettingsGeneral.ui
    DlgSettingsImage.ui
    PreferencePages/DlgSettingsLightSources.ui
    PreferencePages/DlgSettingsMacro.ui
    PreferencePages/DlgSettingsNavigation.ui
    PreferencePages/DlgSettingsNotificationArea.ui
    PreferencePages/DlgSettingsPythonConsole.ui
    PreferencePages/DlgSettingsReportView.ui
    PreferencePages/DlgSettingsSelection.ui
    PreferencePages/DlgSettingsUI.ui
    PreferencePages/DlgSettingsViewColor.ui
    PreferencePages/DlgSettingsWorkbenches.ui
    DlgCheckableMessageBox.ui
    DlgToolbars.ui
    DlgTreeWidget.ui
    DlgLocationAngle.ui
    DlgLocationPos.ui
    DocumentRecovery.ui
    DownloadManager.ui
    DownloadItem.ui
    DlgExpressionInput.ui
    MouseButtons.ui
    SceneInspector.ui
    InputVector.ui
    Placement.ui
    TextureMapping.ui
    TaskView/TaskAppearance.ui
    TaskView/TaskOrientation.ui
    TaskView/TaskImage.ui
    TaskView/TaskSelectLinkProperty.ui
    TaskElementColors.ui
    DlgObjectSelection.ui
    DlgAddProperty.ui
    DlgAddPropertyVarSet.ui
    VectorListEditor.ui
)

if(FREECAD_3DCONNEXION_SUPPORT STREQUAL "Raw input")
	list(APPEND Gui_UIC_SRCS DlgCustomizeSpNavSettings.ui)
endif(FREECAD_3DCONNEXION_SUPPORT STREQUAL "Raw input")

set (FreeCAD_TR_QRC ${CMAKE_CURRENT_BINARY_DIR}/Language/FreeCAD_translation.qrc)
qt_find_and_add_translation(QM_SRCS "Language/FreeCAD_*.ts"
    ${CMAKE_CURRENT_BINARY_DIR}/Language)
qt_create_resource_file_prefix(${FreeCAD_TR_QRC} ${QM_SRCS})
set(Gui_RES_SRCS
    Icons/resource.qrc
    Language/translation.qrc
    ${FreeCAD_TR_QRC}
    QSint/actionpanel/schemes.qrc
)

qt_add_resources(Gui_QRC_SRCS ${Gui_RES_SRCS})

SOURCE_GROUP("Uic" FILES ${Gui_UIC_HDRS})

# The command sources
SET(Command_CPP_SRCS

=== src/Ext/freecad/CMakeLists.txt ===
if (${PYTHON_VERSION_STRING} VERSION_LESS "3.10")
    # deprecated distutils package still required for ubuntu 20.04 and similar
    # see https://bugs.launchpad.net/ubuntu/+source/python3.8/+bug/2039511
    # TODO: remove this once we drop support for 20.04
    EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c
        "from distutils.sysconfig import get_python_lib; print(get_python_lib(plat_specific=True))"
        OUTPUT_VARIABLE python_libs OUTPUT_STRIP_TRAILING_WHITESPACE )
else()
    EXECUTE_PROCESS(COMMAND ${PYTHON_EXECUTABLE} -c
        "from sysconfig import get_path; print(get_path('purelib'))"
        OUTPUT_VARIABLE python_libs OUTPUT_STRIP_TRAILING_WHITESPACE )
endif()

SET(PYTHON_MAIN_DIR ${python_libs})

set(NAMESPACE_DIR "${CMAKE_BINARY_DIR}/Ext/freecad")
set(NAMESPACE_INIT "${NAMESPACE_DIR}/__init__.py")
if (WIN32)
    get_filename_component(FREECAD_LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_BINDIR}"
                       REALPATH BASE_DIR "${CMAKE_INSTALL_PREFIX}")
    set( ${CMAKE_INSTALL_BINDIR})
else()
    get_filename_component(FREECAD_LIBRARY_INSTALL_DIR "${CMAKE_INSTALL_LIBDIR}"
                       REALPATH BASE_DIR "${CMAKE_INSTALL_PREFIX}")
endif()

configure_file(__init__.py.template ${NAMESPACE_INIT})

set(EXT_FILES
    freecad_doc.py
    module_io.py
    part.py
    partdesign.py
    project_utility.py
    sketcher.py
    UiTools.py
    utils.py
)

foreach (it ${EXT_FILES})
    configure_file(${it} ${NAMESPACE_DIR}/${it})
endforeach()

if (INSTALL_TO_SITEPACKAGES)
    SET(SITE_PACKAGE_DIR ${PYTHON_MAIN_DIR}/freecad)
else ()
    SET(SITE_PACKAGE_DIR Ext/freecad)
endif()

INSTALL(
    FILES
        ${NAMESPACE_INIT}
        ${EXT_FILES}
    DESTINATION
        ${SITE_PACKAGE_DIR}
)

=== src/Mod/Idf/CMakeLists.txt ===

SET(Idf_SRCS
    Init.py
    Idf.py
)
SOURCE_GROUP("" FILES ${Idf_SRCS})

SET(IdfLibs_SRCS
    Idflibs/License.txt
    Idflibs/0603_SMD.stp
    Idflibs/0805_SMD.stp
    Idflibs/1206_SMD.stp
    Idflibs/1210_SMD.stp
    Idflibs/1812_SMD.stp
    Idflibs/2225_SMD.stp
    Idflibs/2512_SMD.stp
    Idflibs/CAP_50SGV_8_10.stp
    Idflibs/EPL22_6_16.stp
    Idflibs/footprints_models.csv
    Idflibs/I22_2_5_16.stp
    Idflibs/I22_2_5_16withEPL22_6_16.stp
    Idflibs/MSOP_10.stp
    Idflibs/RLF_12545.stp
    Idflibs/RLF_7030.stp
    Idflibs/SMB_DO_214AA.stp
    Idflibs/SMC_DO_214AB.stp
    Idflibs/SOD_323.igs
    Idflibs/SOD_323.stp
    Idflibs/SOD_523.stp
    Idflibs/SOT23.stp
    Idflibs/SOT404.stp
    Idflibs/SOT428_DPAK.stp
    Idflibs/SOT_323_3.stp
    Idflibs/SOT_96.stp
    Idflibs/TCMT1107_4.stp
    Idflibs/TSM_103_01_L_DV_A.stp
    Idflibs/TSM_104_01_L_DV_A.stp
    Idflibs/TSS0P_8.stp
    Idflibs/VC0603_SMD.stp
    Idflibs/RLF_12545.igs
    Idflibs/SOT23.igs
    Idflibs/SOT404.igs
)
SOURCE_GROUP("Idflibs" FILES ${IdfLibs_SRCS})


SET(all_files ${Idf_SRCS} ${IdfLibs_SRCS} )

ADD_CUSTOM_TARGET(Idf ALL
    SOURCES ${all_files}
)

fc_copy_sources(Idf "${CMAKE_BINARY_DIR}/Mod/Idf" ${all_files})

INSTALL(
    FILES
        ${IdfLibs_SRCS}
    DESTINATION
        Mod/Idf/Idflibs
)
INSTALL(
    FILES
        ${IdfLang_SRCS}
    DESTINATION
        Mod/Idf/Languages
)
INSTALL(
    FILES
        ${Idf_SRCS}
    DESTINATION
        Mod/Idf
)

=== src/Mod/Material/CMakeLists.txt ===
add_subdirectory(App)

if(BUILD_GUI)
    add_subdirectory(Gui)
endif(BUILD_GUI)

SET(MaterialScripts_Files
    Init.py
    InitGui.py
    importFCMat.py
    MaterialEditor.py
    TestMaterialsApp.py
    Templatematerial.yml
)

# SOURCE_GROUP("MaterialScripts" FILES ${MaterialScripts_Files})
SET(MaterialTools_Files
    materialtools/__init__.py
    materialtools/cardutils.py
    materialtools/MaterialModels.py
)

# collect all the material cards:
SET(MaterialLib_Files
    Resources/Materials/Standard/Default.FCMat
    Resources/Materials/Standard/Aggregate/Concrete-EN-C35_45.FCMat
    Resources/Materials/Standard/Aggregate/Concrete-Generic.FCMat
    Resources/Materials/Standard/Aggregate/Reinforcement-FIB-B500.FCMat
    Resources/Materials/Standard/Carbon/Graphite.FCMat
    Resources/Materials/Standard/Glass/Glass-E-GlassFibre.FCMat
    Resources/Materials/Standard/Glass/Glass-Generic.FCMat
    Resources/Materials/Standard/Glass/Glass-S2-GlassFibre.FCMat
    Resources/Materials/Standard/Metal/Alloys/Invar-Generic.FCMat
    Resources/Materials/Standard/Metal/Aluminum/AlMg3F24.FCMat
    Resources/Materials/Standard/Metal/Aluminum/AlMgSi1F31.FCMat
    Resources/Materials/Standard/Metal/Aluminum/Aluminum-6061-T6.FCMat
    Resources/Materials/Standard/Metal/Aluminum/Aluminum-Generic.FCMat
    Resources/Materials/Standard/Metal/Aluminum/AlZn4-5Mg1F35.FCMat
    Resources/Materials/Standard/Metal/Copper/Copper-Generic.FCMat
    Resources/Materials/Standard/Metal/Iron/Iron-Generic.FCMat
    Resources/Materials/Standard/Metal/Steel/CalculiX-Steel.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-15CrNi6.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-17CrNiMo6.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-1C22.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-1C35.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-1C45.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-1C60.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-20NiCrMo2.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-28Mn6.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-2C10.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-30CrNiMo8.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-34CrNiMo6.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-36CrNiMo4.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-36NiCrMo16.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-3C15.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-3C22.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-3C35.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-3V45.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-C10.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-C15.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-C22E.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-C25E.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-C30E.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-C40E.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-C50E.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-C55E.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-C60E.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-E295-GC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-E295.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-E335-GC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-E335.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-E360-GC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-E360.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJL-100.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJL-150.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJL-200.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJL-250.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJL-300.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJL-350.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJMB-350-10.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJMB-550-4.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJMB-650-2.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJMW-350-4.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJMW-360-12.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJMW-400-5.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJMW-450-7.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJS-400-15.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJS-500-7.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJS-600-3.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJS-700-2.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-EN-GJS-800-1.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-G16Mn5.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-G200.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-G20Mn5.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-G230.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-G260.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-G300.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-G30Mn5.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-Generic.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S185.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S235JO.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S235JR.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S235JRG1.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S260NC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S275JO.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S275JR.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S275N.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S335JO.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S335JR.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S335N.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S340MC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S355J2G3.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S380MC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S420MC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S420N.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S460MC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S460N.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S500MC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S550MC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-S690MC.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-St-37-2K.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-St-E-255.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-St-E-315.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-St-E-380.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-St-E-460.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-St-E-500.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-X2CrNiMoN17-13-3.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-X2CrNiN24-4.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-X39CrMo17-1.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-X3CrNiMo13-14.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-X5CrNi18-10.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-X5CrNiMo17-12-2.FCMat
    Resources/Materials/Standard/Metal/Steel/Steel-X6CrNiTi18-10.FCMat
    Resources/Materials/Standard/Metal/Titanium/Ti-6Al-4V.FCMat
    Resources/Materials/Standard/Thermoplast/ABS-Generic.FCMat
    Resources/Materials/Standard/Thermoplast/Acrylic-Glass-Generic.FCMat
    Resources/Materials/Standard/Thermoplast/PA6-Generic.FCMat
    Resources/Materials/Standard/Thermoplast/PET-Generic.FCMat
    Resources/Materials/Standard/Thermoplast/PLA-Generic.FCMat
    Resources/Materials/Standard/Thermoplast/PP-Generic.FCMat
    Resources/Materials/Standard/Thermoplast/PTFE-Generic.FCMat
    Resources/Materials/Standard/Thermoplast/PVC-Generic.FCMat
    Resources/Materials/Standard/Wood/Wood-Generic.FCMat
)

SET(FluidMaterial_Files
    Resources/Materials/Fluid/None.FCMat
    Resources/Materials/Fluid/Air.FCMat
    Resources/Materials/Fluid/Argon.FCMat
    "Resources/Materials/Fluid/Carbon Dioxide.FCMat"
    Resources/Materials/Fluid/Nitrogen.FCMat
    Resources/Materials/Fluid/Water.FCMat
)

SET(AppearanceLib_Files
    Resources/Materials/Appearance/Aluminum.FCMat
    Resources/Materials/Appearance/Brass.FCMat
    Resources/Materials/Appearance/Bronze.FCMat
    Resources/Materials/Appearance/Chrome.FCMat
    Resources/Materials/Appearance/Copper.FCMat
    Resources/Materials/Appearance/Default.FCMat
    Resources/Materials/Appearance/Emerald.FCMat
    Resources/Materials/Appearance/Gold.FCMat
    Resources/Materials/Appearance/Jade.FCMat
    Resources/Materials/Appearance/Metalized.FCMat
    "Resources/Materials/Appearance/Neon GNC.FCMat"
    "Resources/Materials/Appearance/Neon PHC.FCMat"
    Resources/Materials/Appearance/Obsidian.FCMat
    Resources/Materials/Appearance/Pewter.FCMat
    Resources/Materials/Appearance/Plaster.FCMat
    Resources/Materials/Appearance/Plastic.FCMat
    Resources/Materials/Appearance/Ruby.FCMat
    Resources/Materials/Appearance/Satin.FCMat
    "Resources/Materials/Appearance/Shiny Plastic.FCMat"
    Resources/Materials/Appearance/Silver.FCMat
    Resources/Materials/Appearance/Steel.FCMat
    Resources/Materials/Appearance/Stone.FCMat
    Resources/Materials/Appearance/Wood.FCMat
)

SET(PatternLib_Files
    Resources/Materials/Patterns/PAT/Diagonal4.FCMat
    Resources/Materials/Patterns/PAT/Diagonal5.FCMat
    Resources/Materials/Patterns/PAT/Diamond.FCMat
    Resources/Materials/Patterns/PAT/Diamond2.FCMat
    Resources/Materials/Patterns/PAT/Diamond4.FCMat
    Resources/Materials/Patterns/PAT/Horizontal5.FCMat
    Resources/Materials/Patterns/PAT/Square.FCMat
    Resources/Materials/Patterns/PAT/Vertical5.FCMat
    "Resources/Materials/Patterns/Pattern Files/aluminum.FCMat"
    "Resources/Materials/Patterns/Pattern Files/brick01.FCMat"
    "Resources/Materials/Patterns/Pattern Files/concrete.FCMat"
    "Resources/Materials/Patterns/Pattern Files/cross.FCMat"
    "Resources/Materials/Patterns/Pattern Files/cuprous.FCMat"
    "Resources/Materials/Patterns/Pattern Files/diagonal1.FCMat"
    "Resources/Materials/Patterns/Pattern Files/diagonal2.FCMat"
    "Resources/Materials/Patterns/Pattern Files/earth.FCMat"
    "Resources/Materials/Patterns/Pattern Files/general_steel.FCMat"
    "Resources/Materials/Patterns/Pattern Files/glass.FCMat"
    "Resources/Materials/Patterns/Pattern Files/hatch45L.FCMat"
    "Resources/Materials/Patterns/Pattern Files/hatch45R.FCMat"
    "Resources/Materials/Patterns/Pattern Files/hbone.FCMat"
    "Resources/Materials/Patterns/Pattern Files/line.FCMat"
    "Resources/Materials/Patterns/Pattern Files/plastic.FCMat"
    "Resources/Materials/Patterns/Pattern Files/plus.FCMat"
    "Resources/Materials/Patterns/Pattern Files/simple.FCMat"
    "Resources/Materials/Patterns/Pattern Files/solid.FCMat"
    "Resources/Materials/Patterns/Pattern Files/square.FCMat"
    "Resources/Materials/Patterns/Pattern Files/steel.FCMat"
    "Resources/Materials/Patterns/Pattern Files/titanium.FCMat"
    "Resources/Materials/Patterns/Pattern Files/wood.FCMat"
    "Resources/Materials/Patterns/Pattern Files/woodgrain.FCMat"
    "Resources/Materials/Patterns/Pattern Files/zinc.FCMat"
)

SET(MachiningLib_Files
    Resources/Materials/Machining/AluminumCastAlloy.FCMat
    Resources/Materials/Machining/AluminumWroughtAlloy.FCMat
    Resources/Materials/Machining/AusteniticStainlessSteel.FCMat
    Resources/Materials/Machining/BalsaWood.FCMat
    Resources/Materials/Machining/GrayCastIron.FCMat
    Resources/Materials/Machining/HardWood.FCMat

=== tests/src/Mod/CMakeLists.txt ===
if(BUILD_ASSEMBLY)
  add_subdirectory(Assembly)
endif(BUILD_ASSEMBLY)
if(BUILD_MATERIAL)
  add_subdirectory(Material)
endif(BUILD_MATERIAL)
if(BUILD_MESH)
  add_subdirectory(Mesh)
endif(BUILD_MESH)
if(BUILD_MESH_PART)
  add_subdirectory(MeshPart)
endif(BUILD_MESH_PART)
if(BUILD_PART)
  add_subdirectory(Part)
endif(BUILD_PART)
if(BUILD_PART_DESIGN)
  add_subdirectory(PartDesign)
endif(BUILD_PART_DESIGN)
if(BUILD_POINTS)
  add_subdirectory(Points)
endif(BUILD_POINTS)
if(BUILD_SKETCHER)
    add_subdirectory(Sketcher)
endif(BUILD_SKETCHER)

=== src/Mod/Assembly/Gui/CMakeLists.txt ===
include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${COIN3D_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
)

set(AssemblyGui_LIBS
    Assembly
    PartDesign
    PartGui
    Spreadsheet
    SpreadsheetGui
    FreeCADGui
)

PYSIDE_WRAP_RC(Assembly_QRC_SRCS Resources/Assembly.qrc)

set (Assembly_TR_QRC ${CMAKE_CURRENT_BINARY_DIR}/Resources/Assembly_translation.qrc)
qt_find_and_add_translation(QM_SRCS "Resources/translations/*_*.ts"
    ${CMAKE_CURRENT_BINARY_DIR}/Resources/translations)
qt_create_resource_file(${Assembly_TR_QRC} ${QM_SRCS})
qt_add_resources(AssemblyResource_SRCS Resources/Assembly.qrc ${Assembly_TR_QRC})

SOURCE_GROUP("Resources" FILES ${AssemblyResource_SRCS})

generate_from_xml(ViewProviderAssemblyPy)

SET(Python_SRCS
    ViewProviderAssemblyPy.xml
    ViewProviderAssemblyPyImp.cpp
)
SOURCE_GROUP("Python" FILES ${Python_SRCS})

SET(AssemblyGui_SRCS_Module
    AppAssemblyGui.cpp
    AppAssemblyGuiPy.cpp
    PreCompiled.cpp
    PreCompiled.h
    ViewProviderAssembly.cpp
    ViewProviderAssembly.h
    ViewProviderBom.cpp
    ViewProviderBom.h
    ViewProviderBomGroup.cpp
    ViewProviderBomGroup.h
    ViewProviderJointGroup.cpp
    ViewProviderJointGroup.h
    ViewProviderViewGroup.cpp
    ViewProviderViewGroup.h
    ${Assembly_QRC_SRCS}
)

SOURCE_GROUP("Module" FILES ${AssemblyGui_SRCS_Module})


SET(AssemblyGui_SRCS
    ${AssemblyResource_SRCS}
    ${AssemblyGui_UIC_HDRS}
    ${AssemblyGui_SRCS_Module}
    ${Python_SRCS}
)

if(FREECAD_USE_PCH)
    add_definitions(-D_PreComp_)
    GET_MSVC_PRECOMPILED_SOURCE("PreCompiled.cpp" PCH_SRCS ${AssemblyGui_SRCS})
    ADD_MSVC_PRECOMPILED_HEADER(PathGui PreCompiled.h PreCompiled.cpp PCH_SRCS)
endif(FREECAD_USE_PCH)

SET(AssemblyGuiIcon_SVG
    Resources/icons/AssemblyWorkbench.svg
)

add_library(AssemblyGui SHARED ${AssemblyGui_SRCS} ${AssemblyGuiIcon_SVG})

if(WIN32)
    target_compile_definitions(AssemblyGui PRIVATE _USE_MATH_DEFINES)
endif(WIN32)

target_link_libraries(AssemblyGui ${AssemblyGui_LIBS})
if (FREECAD_WARN_ERROR)
    target_compile_warn_error(AssemblyGui)
endif()

SET_BIN_DIR(AssemblyGui AssemblyGui /Mod/Assembly)
SET_PYTHON_PREFIX_SUFFIX(AssemblyGui)

fc_copy_sources(AssemblyGui "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_DATADIR}/Mod/Assembly" ${AssemblyGuiIcon_SVG})
fc_target_copy_resource(AssemblyGui
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_BINARY_DIR}/Mod/Assembly
        Assembly_rc.py)

INSTALL(TARGETS AssemblyGui DESTINATION ${CMAKE_INSTALL_LIBDIR})
INSTALL(FILES ${AssemblyGuiIcon_SVG} DESTINATION "${CMAKE_INSTALL_DATADIR}/Mod/Assembly/Resources/icons")
INSTALL(FILES ${Assembly_QRC_SRCS} DESTINATION Mod/Assembly
)

=== src/Mod/Inspection/App/CMakeLists.txt ===
include_directories(
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${Boost_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${XercesC_INCLUDE_DIRS}
)

link_directories(${OCC_LIBRARY_DIR})

set(Inspection_LIBS
    FreeCADApp
    Mesh
    Points
    Part
)

SET(Inspection_SRCS
    AppInspection.cpp
    InspectionFeature.cpp
    InspectionFeature.h
    PreCompiled.cpp
    PreCompiled.h
)

set(Inspection_Scripts
    ../Init.py
)

if(FREECAD_USE_PCH)
    add_definitions(-D_PreComp_)
    GET_MSVC_PRECOMPILED_SOURCE("PreCompiled.cpp" PCH_SRCS ${Inspection_SRCS})
    ADD_MSVC_PRECOMPILED_HEADER(Inspection PreCompiled.h PreCompiled.cpp PCH_SRCS)
endif(FREECAD_USE_PCH)

add_library(Inspection SHARED ${Inspection_SRCS} ${Inspection_Scripts})
target_link_libraries(Inspection ${Inspection_LIBS})
if (FREECAD_WARN_ERROR)
    target_compile_warn_error(Inspection)
endif()

fc_target_copy_resource_flat(Inspection
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}/Mod/Inspection
    ${Inspection_Scripts}
)

SET_BIN_DIR(Inspection Inspection /Mod/Inspection)
SET_PYTHON_PREFIX_SUFFIX(Inspection)

INSTALL(TARGETS Inspection DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/Mod/ReverseEngineering/App/CMakeLists.txt ===
if (PCL_SURFACE_FOUND AND PCL_FEATURES_FOUND)
    add_definitions(-DHAVE_PCL_SURFACE)

    if(EXISTS "${PCL_INCLUDE_DIRS}/pcl/surface/on_nurbs/fitting_surface_tdm.h")
        add_definitions(-DHAVE_PCL_OPENNURBS)
    endif()
endif ()

if (PCL_FILTERS_FOUND AND PCL_FEATURES_FOUND)
    add_definitions(-DHAVE_PCL_FILTERS)
endif ()

if (PCL_SEGMENTATION_FOUND AND PCL_FEATURES_FOUND)
    add_definitions(-DHAVE_PCL_SEGMENTATION)
endif ()

if (PCL_SAMPLE_CONSENSUS_FOUND)
    add_definitions(-DHAVE_PCL_SAMPLE_CONSENSUS)
endif ()

include_directories(
    ${CMAKE_SOURCE_DIR}/src
    ${Boost_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
    ${XercesC_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
    ${EIGEN3_INCLUDE_DIR}
    ${PCL_INCLUDE_DIRS}
    ${FLANN_INCLUDE_DIRS}
)

link_directories(${OCC_LIBRARY_DIR})

set(Reen_LIBS
    Part
    Mesh
    Points
    FreeCADApp
    ${PCL_COMMON_LIBRARIES}
    ${PCL_KDTREE_LIBRARIES}
    ${PCL_FEATURES_LIBRARIES}
    ${PCL_FILTERS_LIBRARIES}
    ${PCL_SEARCH_LIBRARIES}
    ${PCL_SURFACE_LIBRARIES}
    ${PCL_SEGMENTATION_LIBRARIES}
    ${PCL_SAMPLE_CONSENSUS_LIBRARIES}
    ${QT_QTCORE_LIBRARY}
)

SET(Reen_SRCS
    AppReverseEngineering.cpp
    ApproxSurface.cpp
    ApproxSurface.h
    BSplineFitting.cpp
    BSplineFitting.h
    RegionGrowing.cpp
    RegionGrowing.h
    SampleConsensus.cpp
    SampleConsensus.h
    Segmentation.cpp
    Segmentation.h
    SurfaceTriangulation.cpp
    SurfaceTriangulation.h
    PreCompiled.cpp
    PreCompiled.h
)

if(FREECAD_USE_PCH)
    add_definitions(-D_PreComp_)
    GET_MSVC_PRECOMPILED_SOURCE("PreCompiled.cpp" PCH_SRCS ${Reen_SRCS})
    ADD_MSVC_PRECOMPILED_HEADER(ReverseEngineering PreCompiled.h PreCompiled.cpp PCH_SRCS)
endif(FREECAD_USE_PCH)

add_library(ReverseEngineering SHARED ${Reen_SRCS})
target_link_libraries(ReverseEngineering ${Reen_LIBS})
if (FREECAD_WARN_ERROR)
    target_compile_warn_error(ReverseEngineering)
endif()

SET_BIN_DIR(ReverseEngineering ReverseEngineering /Mod/ReverseEngineering)
SET_PYTHON_PREFIX_SUFFIX(ReverseEngineering)

INSTALL(TARGETS ReverseEngineering DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/Mod/Web/App/CMakeLists.txt ===

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${Boost_INCLUDE_DIRS}
    ${OCC_INCLUDE_DIR}
    ${PYTHON_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIR}
)

include_directories(
    ${QtNetwork_INCLUDE_DIRS}
)
set(Web_LIBS
    FreeCADApp
    ${QtNetwork_LIBRARIES}
)

SET(Web_SRCS
    AppWeb.cpp
    PreCompiled.cpp
    PreCompiled.h
    Server.cpp
    Server.h
)

if(FREECAD_USE_PCH)
    add_definitions(-D_PreComp_)
    GET_MSVC_PRECOMPILED_SOURCE("PreCompiled.cpp" PCH_SRCS ${Web_SRCS})
    ADD_MSVC_PRECOMPILED_HEADER(Web PreCompiled.h PreCompiled.cpp PCH_SRCS)
endif(FREECAD_USE_PCH)

add_library(Web SHARED ${Web_SRCS})
target_link_libraries(Web ${Web_LIBS})
if (FREECAD_WARN_ERROR)
    target_compile_warn_error(Web)
endif()

SET_BIN_DIR(Web Web /Mod/Web)
SET_PYTHON_PREFIX_SUFFIX(Web)

install(TARGETS Web DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== tests/src/Mod/Sketcher/CMakeLists.txt ===

target_include_directories(Sketcher_tests_run PUBLIC
    ${EIGEN3_INCLUDE_DIR}
    ${OCC_INCLUDE_DIR}
    ${Python3_INCLUDE_DIRS}
    ${XercesC_INCLUDE_DIRS}
)

target_link_libraries(Sketcher_tests_run
    gtest_main
    ${Google_Tests_LIBS}
    Sketcher
)

add_subdirectory(App)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=freecad
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.0rc2
pkgrel=1
_OS_commit=91f70382
pkgdesc="Free and Opensource multiplatform 3D parametric modeler (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://freecadweb.org/'
msys2_repository_url="https://github.com/FreeCAD/FreeCAD"
msys2_references=(
  'archlinux: freecad'
)
license=('spdx:GPL-2.0-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-boost"
         "${MINGW_PACKAGE_PREFIX}-coin"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-med"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-opencascade"
         "${MINGW_PACKAGE_PREFIX}-openscad"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-python-numpy"
         "${MINGW_PACKAGE_PREFIX}-python-packaging"
         "${MINGW_PACKAGE_PREFIX}-python-pivy"
         "${MINGW_PACKAGE_PREFIX}-pyside6"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-svg"
         "${MINGW_PACKAGE_PREFIX}-xerces-c"
         "${MINGW_PACKAGE_PREFIX}-vtk"
         "${MINGW_PACKAGE_PREFIX}-yaml-cpp"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-python-matplotlib"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools"
             "${MINGW_PACKAGE_PREFIX}-swig"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-microsoft-gsl"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
source=("https://github.com/FreeCAD/FreeCAD/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "https://github.com/Ondsel-Development/OndselSolver/archive/${_OS_commit}/OndselSolver-${_OS_commit}.tar.gz")
sha256sums=('4ed61d1a91039e5ad465bc19313bc95422d93b52b0135c63b628e59778d29512'
            '061f651f503f1ec5a9814e174cdb8a9ba84d511a3b8be3d94852e84976c6b158')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  mv OndselSolver-*/* ${_realname}-${pkgver}/src/3rdParty/OndselSolver/

  cd ${_realname}-${pkgver}
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CC} == clang ]]; then
    CXXFLAGS+=" -Wno-macro-redefined"
  else
    CXXFLAGS+=" -Wno-template-id-cdtor"
  fi

  CXXFLAGS+=" -Wno-deprecated-declarations -Wno-unknown-pragmas" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=;" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DFREECAD_QT_VERSION="6" \
      -DBUILD_TEST=OFF \
      -DBUILD_WEB=OFF \
      -DENABLE_DEVELOPER_TESTS=OFF \
      -DINSTALL_TO_SITEPACKAGES=OFF \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      -DPYTHON_EXECUTABLE=${MINGW_PREFIX}/bin/python \
      "${_extra_config[@]}" \
      ../${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  MSYS2_ARG_CONV_EXCL="-d" \
    python -m compileall -o 0 -o 1 -q -d"${MINGW_PREFIX}" "${pkgdir}${MINGW_PREFIX}"
}
